Package: ooplah
Title: Helper Functions for Class Object-Oriented Programming
Version: 0.2.0
Authors@R:
    person(given = "Raphael",
           family = "Sonabend",
           role = c("aut", "cre"),
           email = "raphaelsonabend@gmail.com",
           comment = c(ORCID = "0000-0001-9225-4654"))
Description: Helper functions for coding object-oriented programming with
    a focus on R6. Includes functions for assertions and testing, looping,
    and re-usable design patterns including Abstract and Decorator
    classes.
License: MIT + file LICENSE
URL: https://xoopR.github.io/ooplah/, https://github.com/xoopR/ooplah
BugReports: https://github.com/xoopR/ooplah/issues
Imports:
    R6
Suggests:
    devtools,
    testthat,
    withr
Config/testthat/edition: 3
Encoding: UTF-8
LazyData: true
Roxygen: list(markdown = TRUE, r6 = TRUE)
RoxygenNote: 7.1.1
SystemRequirements: C++11

ooplah
================

<img src="man/figures/logo.png" align="right" alt="" width="120" />

[![CRAN Status
Badge](https://www.r-pkg.org/badges/version-ago/ooplah)](https://cran.r-project.org/package=ooplah)
[![CRAN
Checks](https://cranchecks.info/badges/worst/ooplah)](https://cran.r-project.org/web/checks/check_results_ooplah.html)
[![R-CMD-check /
codecov](https://github.com/xoopR/ooplah/actions/workflows/check-covr.yml/badge.svg?branch=main)](https://github.com/xoopR/ooplah/actions/workflows/check-covr.yml)

[![Repo
Status](https://www.repostatus.org/badges/latest/active.svg)](https://github.com/xoopR/ooplah)
[![Lifecycle](https://lifecycle.r-lib.org/articles/figures/lifecycle-experimental.svg)](https://github.com/xoopR/ooplah)

[![CRAN
Downloads](https://cranlogs.r-pkg.org/badges/grand-total/ooplah)](https://cran.r-project.org/package=ooplah)
[![codecov](https://app.codecov.io/gh/xoopR/ooplah/branch/main/graph/badge.svg)](https://app.codecov.io/gh/xoopR/ooplah)
[![dependencies](https://tinyverse.netlify.com/badge/ooplah)](https://CRAN.R-project.org/package=ooplah)
[![License:
MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)

## What is ooplah?

**ooplah** contains helper functions for object-oriented programming in
R, with a focus on R6. These functions are used throughout the xoop
universe but can be useful in any package.

## Installation

For the latest release on
[CRAN](https://CRAN.R-project.org/package=ooplah), install with

``` r
install.packages("ooplah")
```

Otherwise for the latest stable build

``` r
remotes::install_github("xoopR/ooplah")
```

## Future Plans

The **ooplah** API is still experimental and may be subject to major
changes. Currently it’s primary use-case is in other xoopR packages,
minor or major changes will be made to satisfy this dependency. Future
development will then focus on code quality and speed.

## Package Development and Contributing

**ooplah** is released under the [MIT
licence](https://opensource.org/licenses/MIT). We welcome and appreciate
all [new issues](https://github.com/xoopR/ooplah/issues) relating to bug
reports, questions and suggestions. You can also [start a
discussion](https://github.com/xoopR/ooplah/discussions) for more
extensive feedback or feature suggestion.

---
title: "ooplah"
output: github_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
library(ooplah)
ref <- function(val) sprintf("[%s](https://xoopr.github.io/ooplah/reference/%s.html)",
                             as.character(substitute(val)),
                             as.character(substitute(val)))
cran <- function(val) sprintf("**[%s](https://CRAN.R-project.org/package=%s)**",
                              as.character(substitute(val)),
                              as.character(substitute(val)))
gh <- function(org, repo) sprintf("**[%s](https://github.com/%s/%s)**", repo, org, repo)
pkg <- function(pkg) sprintf("**%s**", as.character(substitute(pkg)))
ol <- "**ooplah**"
```

<img src="man/figures/logo.png" align="right" alt="" width="120" />

[![CRAN Status Badge](https://www.r-pkg.org/badges/version-ago/ooplah)](https://cran.r-project.org/package=ooplah)
[![CRAN Checks](https://cranchecks.info/badges/worst/ooplah)](https://cran.r-project.org/web/checks/check_results_ooplah.html)
[![R-CMD-check / codecov](https://github.com/xoopR/ooplah/actions/workflows/check-covr.yml/badge.svg?branch=main)](https://github.com/xoopR/ooplah/actions/workflows/check-covr.yml)

[![Repo Status](https://www.repostatus.org/badges/latest/active.svg)](https://github.com/xoopR/ooplah)
[![Lifecycle](https://lifecycle.r-lib.org/articles/figures/lifecycle-experimental.svg)](https://github.com/xoopR/ooplah)

[![CRAN Downloads](https://cranlogs.r-pkg.org/badges/grand-total/ooplah)](https://cran.r-project.org/package=ooplah)
[![codecov](https://app.codecov.io/gh/xoopR/ooplah/branch/main/graph/badge.svg)](https://app.codecov.io/gh/xoopR/ooplah)
[![dependencies](https://tinyverse.netlify.com/badge/ooplah)](https://CRAN.R-project.org/package=ooplah)
[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)

## What is ooplah?

`r ol` contains helper functions for object-oriented programming in R, with a focus on R6. These functions are used throughout the xoop universe but can be useful in any package.

## Installation

For the latest release on [CRAN](https://CRAN.R-project.org/package=ooplah), install with
```{r eval=FALSE}
install.packages("ooplah")
```

Otherwise for the latest stable build
```{r eval=FALSE}
remotes::install_github("xoopR/ooplah")
```

## Future Plans

The `r ol` API is still experimental and may be subject to major changes. Currently it's primary use-case is in other xoopR packages, minor or major changes will be made to satisfy this dependency. Future development will then focus on code quality and speed.

## Package Development and Contributing

`r ol` is released under the [MIT licence](https://opensource.org/licenses/MIT). We welcome and appreciate all [new issues](https://github.com/xoopR/ooplah/issues) relating to bug reports, questions and suggestions. You can also [start a discussion](https://github.com/xoopR/ooplah/discussions) for more extensive feedback or feature suggestion.

.vxapply <- function(type) {
  function(X, FUN, ..., USE.NAMES = TRUE) { # nolint
    if (is.function(FUN)) {
      vapply(X, FUN, type, ..., USE.NAMES = USE.NAMES)
    } else {
      vapply(X, function(.x)  {
        .f <- .x[[FUN]]
        if (is.function(.f)) {
          .f(...)
        } else {
          .f
        }
      }, type, USE.NAMES = USE.NAMES)
    }
  }
}

#' Specialised `vapply` functions for scalars of each of the six atomic classes
#' in R:
#'
#' * logical (`vlapply`)
#' * integer (`viapply`)
#' * numeric/real (`vnapply`)
#' * character/string (`vcapply`)
#' * complex (`vzapply`)
#' * raw (`vrapply`)
#'
#' These are simply wrappers around [vapply] where `FUN.VALUE` is pre-filled
#' with a scalar of the given class.
#'
#' In addition these can be applied to pull-out fields or methods from R6 or
#' other OOP objects by supplying the field/method name to `FUN`. See examples.
#' @title Specialised vapply methods for atomic classes
#' @name vxapply
#' @param X,...,USE.NAMES See [vapply]
#' @param FUN Either a function to apply to each element of `X`, as in [vapply]
#' or the field/method name of an OOP object (see examples)
#' @examples
#' ## Specialised vapply
#' vlapply(logical(10), identity)
#' vzapply(complex(10), identity)
#'
#' ## For R6 objects
#' objs <- list(ooplah$new(), ooplah$new())
#'
#' # Public field
#' vcapply(objs, "oop")
#'
#' # Public method
#' vcapply(objs, "exclaim", "ARGH")
#' vcapply(objs, "hello")
#' vnapply(objs, "generate", 1)
#'
#' # Active binding
#' vlapply(objs, "logically")
NULL

#' @rdname vxapply
#' @export
vlapply <- .vxapply(logical(1))
#' @rdname vxapply
#' @export
viapply <- .vxapply(integer(1))
#' @rdname vxapply
#' @export
vnapply <- .vxapply(numeric(1))
#' @rdname vxapply
#' @export
vcapply <- .vxapply(character(1))
#' @rdname vxapply
#' @export
vzapply <- .vxapply(complex(1))
#' @rdname vxapply
#' @export
vrapply <- .vxapply(raw(1))


#' Specialised `lapply` functions for R6 or other OOP classes.
#' This is simply a wrapper that detects if `FUN` is a function, in which
#' case `lapply` is used as usual, or a string, in which case the given
#' field/method is returned as a list.
#' @title Specialised lapply for objects
#' @param X,... See [lapply]
#' @param FUN Either a function to apply to each element of `X`, as in [lapply]
#' or the field/method name of an OOP object (see examples)
#' @export
#' @examples
#' ## lapply as usual
#' loapply(c(1, 2, 3), identity)
#'
#' ## For R6 objects
#' objs <- list(ooplah$new(), ooplah$new())
#' # Public field
#' loapply(objs, "oop")
#' # Public method
#' loapply(objs, "hello")
loapply <- function(X, FUN, ...) {
  if (is.function(FUN)) {
    lapply(X, FUN, ...)
  } else {
    lapply(X, function(.x) {
      .f <- .x[[FUN]]
      if (is.function(.f) && ...length()) {
        if (is.null(formals(.f))) {
          .f()
        } else {
          .f(...)
        }
      } else {
        .f
      }
    })
  }
}

test_that("vxapply", {
 expect_equal(vlapply(logical(10), identity), logical(10))
 expect_equal(vzapply(complex(10), identity), complex(10))
 expect_error(vlapply(complex(1), identity), "logical")

 objs <- list(ooplah$new(), ooplah$new())
 expect_equal(vcapply(objs, "oop"), rep("oop", 2))

 # Public method
 expect_equal(vcapply(objs, "exclaim", "ARGH"), rep("ARGH!", 2))
 expect_equal(vcapply(objs, "hello"), rep("Hello World, Ooplah!", 2))
 expect_type(vnapply(objs, "generate", 1), "double")
 expect_equal(length(vnapply(objs, "generate", 1)), 2)

 # Active binding
 expect_equal(vlapply(objs, "logically"), rep(TRUE, 2))
})

test_that("loapply", {
  expect_equal(loapply(c(1, 2, 3), identity), list(1, 2, 3))

 ## For R6 objects
 objs <- list(ooplah$new(), ooplah$new())
 # Public field
 expect_equal(loapply(objs, "oop"), list("oop", "oop"))
 # Public method
 expect_equal(vcapply(loapply(objs, "hello"), do.call, list()),
              rep("Hello World, Ooplah!", 2))
 expect_equal(loapply(objs, "hello", NULL),
              rep(list("Hello World, Ooplah!"), 2))
 expect_equal(loapply(objs, "exclaim", "Lah"),
              rep(list("Lah!"), 2))
})

test_that(".vxapply", {
  expect_equal(.vxapply(integer(1))(1L, identity), 1L)
})

test_that("vxapply work and error as expected", {
  expect_equal(vlapply(TRUE, identity), TRUE)
  expect_error(vlapply("a", identity))

  expect_equal(viapply(1L, identity), 1L)
  expect_error(viapply("a", identity))

  expect_equal(vnapply(pi, identity), pi)
  expect_error(vnapply("a", identity))

  expect_equal(vcapply("a", identity, USE.NAMES = FALSE), "a")
  expect_error(vcapply(2, identity))

  expect_equal(vzapply(1i, identity), 1i)
  expect_error(vzapply("a", identity))

  expect_equal(vrapply(raw(1), identity), raw(1))
  expect_error(vrapply("a", identity))
})

#' R6 Class for testing and examples
#' @title R6 Class for testing and examples
#' @name ooplah
#' @export
NULL

OoplahParent <- AbstractClass("OoplahParent",
  public = list(
    initialize = function(x) {
      private$.init <- TRUE
      invisible(self)
    }
  ),
  active = list(
    init = function() private$.init
  ),
  private = list(
    .init = FALSE
  )
)

ooplah <- R6Class("ooplah",
  inherit = OoplahParent,
  public = list(
    hello = function() "Hello World, Ooplah!",
    oop = "oop",
    exclaim = function(x) sprintf("%s!", x),
    generate = function(n = 1) runif(n)
  ),
  active = list(
    logically = function(x) {
      if (missing(x)) {
        private$.lgl
      } else {
        stopifnot(is.logical(x))
        private$.lgl <- x
      }
    }
  ),
  private = list(
    .goodbye = "Goodbye World",
    .lgl = TRUE
  )
)

oopl <- ooplah$new()
dec <- DecoratorClass("dec",
  public = list(
    sleep = function() "Zzzz"
  ),
  active = list(test = function(x) {
    if (missing(x)) private$.test else private$.test <- x
  }),
  private = list(.test = FALSE),
  abstract = TRUE
)
dec_child <- DecoratorClass("dec_child", inherit = dec)
dec_child2 <- DecoratorClass("dec_child2", inherit = dec)
obj_dec <- dec_child$new(oopl)

test_that("can create a decorator class", {
  expect_equal(class(DecoratorClass("dec")$new(oopl)),
               c("dec", "ooplah", "OoplahParent", "Decorator", "R6"))
})

test_that("cannot construct an abstractor decorator", {
  expect_error(dec$new(oopl), "abstract class")
})


test_that("can construct a decorator's child", {
  expect_equal(class(obj_dec),
                c("dec_child", "dec", "ooplah", "OoplahParent", "Decorator",
                  "R6"))
  expect_equal(obj_dec$sleep(), "Zzzz")
  expect_equal(obj_dec[["sleep"]](), "Zzzz")
  expect_false(obj_dec$test)
  expect_false(obj_dec[["test"]])
  obj_dec[["test"]] <- TRUE
  expect_true(obj_dec$test)
  expect_true(obj_dec[["test"]])
  obj_dec$test <- FALSE
  expect_false(obj_dec$test)
  expect_false(obj_dec[["test"]])
})

test_that("can access original methods/fields", {
  expect_equal(obj_dec$hello(), "Hello World, Ooplah!")
  expect_equal(obj_dec$init, TRUE)
})

test_that("active bindings work", {
  obj_dec$logically <- FALSE
  expect_false(obj_dec$logically)

  obj_dec[["logically"]] <- TRUE
  expect_true(obj_dec[["logically"]])
})

test_that("error on decorating existing methods", {
  exists <- DecoratorClass("exists", public  = list(hello = function() "Oh no"))
  expect_error(exists$new(oopl, exists = "error"), "Fields/methods")
})

test_that("skip on decorating existing methods - $", {
  exists <- DecoratorClass("exists",
    public = list(hello = function() "Oh no", goodbye = function() "Bye")
  )
  dec <- exists$new(oopl, exists = "skip")
  expect_equal(private(dec)$ooplah$.exists, "skip")
  expect_equal(dec$hello(), "Hello World, Ooplah!")
  expect_equal(dec$goodbye(), "Bye")
  expect_equal(dec$oop, "oop")
})


test_that("skip on decorating existing methods - [[", {
  exists <- DecoratorClass("exists",
    public = list(hello = function() "Oh no", goodbye = function() "Bye")
  )
  dec <- exists$new(oopl, exists = "skip")
  expect_equal(private(dec)$ooplah$.exists, "skip")
  expect_equal(dec[["hello"]](), "Hello World, Ooplah!")
  expect_equal(dec[["goodbye"]](), "Bye")
  expect_equal(dec[["oop"]], "oop")

  expect_equal(dec, exists$new(oopl))
})

test_that("skip on decorating existing methods - switch to field", {
  exists <- DecoratorClass("exists", public  = list(hello = "Oh no"))
  expect_equal(exists$new(oopl, exists = "skip")$hello(),
              "Hello World, Ooplah!")
})

test_that("overwrite on decorating existing methods - $", {
  exists <- DecoratorClass("exists",
    public = list(hello = function() "Oh no", goodbye = function() "Bye")
  )
  dec <- exists$new(oopl, exists = "overwrite")
  expect_equal(private(dec)$ooplah$.exists, "overwrite")
  expect_equal(dec$hello(), "Oh no")
  expect_equal(dec$goodbye(), "Bye")
  expect_equal(dec$oop, "oop")
})

test_that("overwrite on decorating existing methods - [[", {
  exists <- DecoratorClass("exists",
    public = list(hello = function() "Oh no", goodbye = function() "Bye")
  )
  dec <- exists$new(oopl, exists = "overwrite")
  expect_equal(private(dec)$ooplah$.exists, "overwrite")
  expect_equal(dec[["hello"]](), "Oh no")
  expect_equal(dec[["goodbye"]](), "Bye")
  expect_equal(dec[["oop"]], "oop")
})

test_that("can't clone a decorator", {
  oopl <- ooplah$new()

  expect_error(DecoratorClass("clone", cloneable = TRUE), "not cloneable")
  dec <- DecoratorClass("clone")$new(oopl)

  expect_equal(dec$clone, NULL)
  expect_error(dec$clone(), "attempt to apply")

  expect_equal(dec[["clone"]], NULL)
  expect_error(dec[["clone"]](), "attempt to apply")

  # original clone still works
  oopl2 <- oopl$clone(deep = TRUE)
  oopl$logically <- FALSE
  expect_true(oopl2$logically)
  expect_false(oopl$logically)
  expect_false(dec$logically)
})

test_that("can't decorate twice", {
  oop <- ooplah$new()

  dec1 <- DecoratorClass("dec1")
  dec2 <- DecoratorClass("dec2")

  oop_dec1 <- dec1$new(oop)

  expect_error(dec1$new(oop_dec1), "already decorated with")

  oop_dec2 <- dec2$new(oop_dec1)

  expect_error(dec1$new(oop_dec2), "already decorated with")
  expect_error(dec2$new(oop_dec2), "already decorated with")
})

test_that("decorate sugar - env", {
  oop <- ooplah$new()
  d1 <- decorate(oop, c(dec_child, dec_child2))

  oop <- ooplah$new()
  d2 <- decorate(oop, c(dec_child, dec_child2))

  expect_identical(d1, d2)
})

#' @title Sugar function for decoration
#' @description Simple wrapper around `decorator$new(object, exists)`
#'
#' @param object `[R6::R6Class]` \cr R6 class to decorate.
#' @param decorators `([DecorateClass]|character())` \cr
#' One or more decorators (by name or class) to decorate with.
#' @param exists `(character(1)` \cr Expected behaviour if method exists in
#' `object` and `decorator`. One of: 1. `exists = "error"` (default) - This
#' will throw an error and prevent the object being decorated.
#' 2. `exists = "skip"` - This will decorate the object with all fields/methods
#' that don't already exist. 3. `exists = "overwrite"` - This will decorate
#' the object with all fields/methods from the decorator and overwrite ones
#' with the same name if they already exist.
#' @param ... `ANY` \cr Additional arguments passed to [get].
#'
#' @seealso
#' [DecoratorClass]
#'
#' @examples
#' library(R6)
#'
#' ## Define decorators
#' dec1 <- DecoratorClass("dec1", public = list(goodbye = "Goodbye World"))
#' dec2 <- DecoratorClass("dec2", public = list(goodbye2 = "Goodbye World 2"))
#'
#' oop <- ooplah$new()
#' oop$goodbye
#' dec_oop <- decorate(oop, c(dec1, dec2))
#' dec_oop$goodbye
#' dec_oop$goodbye2
#'
#' ## Equivalently
#' oop <- ooplah$new()
#' decorate(oop, c("dec1", "dec2"))
#'
#' @export
decorate <- function(object, decorators,
                    exists = c("skip", "error", "overwrite"), ...) {
  for (decorator in decorators) {
    if (is.character(decorator)) {
      object <- get(decorator, ...)$new(object, exists) # nocov
    } else {
      object <- decorator$new(object, exists)
    }
  }

  object
}

#' Access the private environment of an R6 object
#' @title Get R6 object private environment
#' @param x (`R6`) \cr R6 object to get environment from, errors if not R6
#' @export
private <- function(x) {
  stopifnot(is.R6Object(x))
  x$.__enclos_env__$private
}

#' Access the parent environment of an R6 object
#' @title Get R6 object parent environment
#' @param x (`R6`) \cr R6 object to get environment from, errors if not R6
#' @export
super <- function(x) {
  stopifnot(is.R6Object(x))
  x$.__enclos_env__$super
}

test_that("private works", {
  obj <- ooplah$new()
  expect_identical(private(obj), obj$.__enclos_env__$private)
})

test_that("super works", {
  obj <- ooplah$new()
  expect_identical(super(obj), obj$.__enclos_env__$super)
})

test_that("ooplah class behaves as expected", {
  obj <- ooplah$new()
  expect_equal(private(obj)$.goodbye, "Goodbye World")
  expect_true(obj$logically)
  obj$logically <- FALSE
  expect_false(obj$logically)
})

#' Creates a decorator R6 class by placing a thin wrapper around [R6::R6Class]
#' which allows the constructed class to inherit the fields and methods of
#' the given object.
#' @title Create an abstract R6 Class
#' @name DecoratorClass
#' @details
#' The decorator design pattern allows methods to be added to an
#' object without bloating the interface with too many methods on construction
#' and without causing large inheritance trees. A decorator class contains
#' fields/methods that are 'added' to the given object in construction, this
#' is made clearer in examples.
#'
#' There are three possibilities when trying to decorate an object with a
#' field/method that already exists:
#'
#' 1. `exists = "skip"` (default) - This will decorate the object with all
#' fields/methods that don't already exist
#' 2. `exists = "error"` - This will throw an error and prevent the
#' object being decorated
#' 3. `exists = "overwrite"` - This will decorate the object with all
#' fields/methods from the decorator and overwrite ones with the same name
#' if they already exist
#'
#' Decorators are currently not cloneable.
#'
#' All arguments of [R6::R6Class] can be used as usual, see full
#' details at [R6::R6Class].
#'
#' @references
#' Gamma, E., Helm, R., Johnson, R., & Vlissides, J. (1996).
#' Design Patterns: Elements of Reusable Software.
#' Addison-Wesley Professional Computing Series (p. 395).
#'
#' @seealso
#' [decorate]
#'
#' @export
#'
#' @examples
#' library(R6)
#'
#' ## Create two decorators
#' # Works with active bindings...
#' dec1 <- DecoratorClass("dec1", active = list(hi = function() "Hi World"))
#' # And public fields...
#' dec2 <- DecoratorClass("dec2", public = list(goodbye = "Goodbye World"))
#'
#' ## Create an object to decorate
#' oop <- ooplah$new()
#' oop$hello()
#'
#'
#' ## Decorate with dec1 by constructing dec1 with object oop:
#' dec_oop <- dec1$new(oop) # equiv `decorate(oop, dec1)`
#' ## We have all original methods from oop
#' dec_oop$hello()
#' # It's inherited methods
#' dec_oop$init
#' # And now decorated methods
#' dec_oop$hi
#'
#' ## We can decorate again
#' redec_oop <- dec2$new(dec_oop)
#' redec_oop$hello()
#' redec_oop$init
#' redec_oop$hi
#' # And now
#' redec_oop$goodbye
#'
#' # Notice the class reflects all decorators, the original object and parents,
#' #  and adds the 'Decorator' class
#' class(redec_oop)
#'
#' ## Decorators also work with inheritance
#' parent_dec <- DecoratorClass("parent_dec",
#'   public = list(hi = function() "Hi!"))
#' child_dec <- DecoratorClass("child_dec", inherit = parent_dec)
#' dec_oop <- child_dec$new(ooplah$new())
#' dec_oop$hi()
#'
#' ## Three possibilities if the method/field name already exists:
#' oop <- ooplah$new()
#' exists_dec <- DecoratorClass("exists_dec",
#'   public = list(hello = function() "Hi!"))
#'
#' # 1. skip (default)
#' oop$hello()
#' exists_dec$new(oop, exists = "skip")$hello()
#'
#' # 2. error
#' \dontrun{
#' exists_dec$new(oop)
#' exists_dec$new(oop, exists = "error")
#' }
#'
#' # 3. overwrite
#' oop$hello()
#' exists_dec$new(oop, exists = "overwrite")$hello()
#'
#' ## Cloning
#' # Note that by default the decorated object is not cloned
#' dec <- DecoratorClass("dec", active = list(hi = function() "Hi World"))
#' dec_oop <- dec$new(oop)
#' dec_oop$logically
#' oop$logically <- FALSE
#' dec_oop$logically
#'
NULL

DecoratorClass <- function() {

  init <- function(self) {
    function(object, exists = c("skip", "error", "overwrite")) {
      private$ooplah$fabstract(self)

      exists <- match.arg(exists)

      self_mf <- setdiff(ls(self), c("clone", "initialize"))
      which <- self_mf %in% setdiff(ls(object), c("clone", "initialize"))
      if (any(which)) {
        if (exists == "error") {
          stop(sprintf("Fields/methods already exist in %s: %s",
                      as.character(object), str_collapse(self_mf[which])))
        } else {
          private$ooplah$.exists <- exists
        }
      }

      parent.env(self) <- object

      private$ooplah$decorators <- c(private(object)$ooplah$decorators,
                                    object_class(self))

      if (object_class(self) %in% class(object)) {
        stop(sprintf("%s is already decorated with %s", as.character(object),
                    as.character(self)))
      }

      ## Inherit from an abstract (in the truest sense of the word) 'Decorator'
      ##  class
      class(self) <- c(setdiff(c(setdiff(class(self), "R6"), class(object)),
                              c("Decorator", "R6")),
                      c("Decorator", "R6"))

      for (nm in names(private(object))) {
        if (nm != "ooplah") {
          private[[nm]] <- private(object)[[nm]]
        }
      }

      invisible(self)
    }
  }

  args <- as.list(match.call()[-1])
  args$private$ooplah <- new.env()
  args$private$ooplah$.exists <- "error"
  args$public$initialize <- init(self)
  args$abstract <- NULL
  if (!is.null(args$cloneable) && args$cloneable) {
    stop("Decorators are currently not cloneable.")
  }
  args$parent_env <- args$parent_env %||% parent.frame()
  args$cloneable <- FALSE
  args$lock_objects <- FALSE
  args$lock_class <- FALSE
  if (abstract) {
    args$private$ooplah$abstract <- classname
  } else {
    args$private$ooplah$abstract <- NULL
  }
  args$private$ooplah$fabstract <- function(obj) {
    if (identical(classname <- object_class(obj),
                  private(obj)$ooplah$abstract)) {
      stop(sprintf(
          "'%s' is an abstract class that can't be initialized.",
          classname
        ),
        call. = FALSE
      )
    }
  }
  do.call(R6::R6Class, args)
}
formals(DecoratorClass) <- c(formals(R6::R6Class), alist(abstract = FALSE))

#' @export
`$.Decorator` <- function(x, name) { # nolint

  if (name == ".__enclos_env__") {
    return(NextMethod("$"))
  } else if (name == "clone") {
    return(NULL)
  }

  ## if skipping then search in parent environment first
  if (private(x)$ooplah$.exists == "skip") {
    if (!identical(out <- get0(name, parent.env(x), ifnotfound = NA), NA)) {
      out
      ## then check main environment
    } else if (!identical(out <- get0(name, x, ifnotfound = NA), NA)) {
      out
    }
  } else {
    ## if overwriting then get0 prioritises main
    if (!identical(out <- get0(name, x, ifnotfound = NA), NA)) {
      out
    }
  }
}

#' @export
`$<-.Decorator` <- function(x, i, j, ..., value) { # nolint

  if (exists(i, x, inherits = FALSE)) {
    NextMethod("$<-")
  } else {
    parent.env(x)[[i]] <- value
  }

  invisible(x)
}

#' @export
`[[.Decorator` <- function(x, i, ...) { # nolint

  if (i == "clone") {
    return(NULL)
  }

  ## if skipping then search in parent environment first
  if (private(x)[["ooplah"]][[".exists"]] == "skip") {
    if (!identical(out <- get0(i, parent.env(x), ifnotfound = NA), NA)) {
      out
      ## then check main environment
    } else if (!identical(out <- get0(i, x, ifnotfound = NA), NA)) {
      out
    }
  } else {
    ## if overwriting then get0 prioritises main
    if (!identical(out <- get0(i, x, ifnotfound = NA), NA)) {
      out
    }
  }
}

#' @export
`[[<-.Decorator` <- function(x, i, j, ..., value) { # nolint
  if (exists(i, x, inherits = FALSE)) {
    NextMethod("[[<-")
  } else {
    parent.env(x)[[i]] <- value
  }

  invisible(x)
}

#' Find class of an object or an ancestor of the object. In contrast to `class`
#' which returns a class object and all its ancestors, this function returns
#' either the class of the object itself, or the class of one of its ancestors.
#'
#' `object_classes` is a stripped-down wrapper to get the class of multiple
#' objects
#' @title Get class of an object (possibly with inheritance)
#' @param object `ANY` \cr Object to get the class of
#' @param ancestor `(integer(1))` \cr If greater than 0 then the given ancestor
#' to get the class for, see examples
#' @export
#' @examples
#' library(R6)
#'
#' class_a <- R6Class("class_a")
#' class_b <- R6Class("class_b", inherit = class_a)
#' class(class_b$new())
#' object_class(class_b$new())
#' object_class(class_b$new(), 1)
object_class <- function(object, ancestor = 0) {
    class(object)[[ancestor + 1]]
}

#' @rdname object_class
#' @param ... `ANY` \cr Passed to [get]
#' @export
get_object_class <- function(object, ancestor = 0, ...) {
  get(object_class(object, ancestor), ...)
}

#' @rdname object_class
#' @param ... `ANY` \cr Objects to `vapply` over
#' @param objects `(list(1))` \cr Alternative constructor with `list` of objects
#' @export
object_classes <- function(..., objects = list(...)) {
  vcapply(objects, object_class)
}

objah <- ooplah$new()

test_that("object_class", {
  expect_equal(object_class(objah), "ooplah")
  expect_equal(object_class(objah, 1), "OoplahParent")
  expect_equal(object_class(objah, 2), "R6")
})

test_that("get_object_class", {
  expect_equal(get_object_class(objah), ooplah)
  expect_equal(get_object_class(objah, 1)$classname, OoplahParent$classname)
})

test_that("object_classes", {
  expect_equal(object_classes(objah, objah), rep("ooplah", 2))
  expect_equal(object_classes(objects = list(objah, objah)), rep("ooplah", 2))
})

#' Creates an abstract R6 class by placing a thin wrapper around [R6::R6Class]
#' which causes an error to be thrown if the class is directly constructed
#' instead of one of its descendants.
#' @title Create an abstract R6 Class
#' @name AbstractClass
#' @details An abstract class is a class that cannot be constructed directly.
#' Instead they are used to define common fields/methods for child classes
#' that inherit from them.
#'
#' All arguments of [R6::R6Class] can be used as usual, see full
#' details at [R6::R6Class].
#' @examples
#' library(R6)
#'
#' ab <- AbstractClass("abstract", public = list(hello = "Hello World"))
#' \dontrun{
#' # errors
#' ab$new()
#' }
#' child <- R6Class("child", inherit = ab)
#' child$new()$hello
#'
#' @references
#' Gamma, E., Helm, R., Johnson, R., & Vlissides, J. (1996).
#' Design Patterns: Elements of Reusable Software.
#' Addison-Wesley Professional Computing Series (p. 395).
#'
#' @export
NULL

AbstractClass <- function() {

  args <- as.list(match.call()[-1])
  public <- args$public
  args$private$ooplah <- new.env()
  if (is.null(init <- public$initialize)) {
    public$initialize <- function() {
      private$ooplah$fabstract(self)
    }
  } else {
    args$private$ooplah$init <- init
    public$initialize <- function() {
      private$ooplah$fabstract(self)
      do.call(eval(private$ooplah$init), as.list(match.call()[-1]))
    }
    formals(public$initialize) <- formals(eval(init))
  }

  args$public <- public
  args$parent_env <- args$parent_env %||% parent.frame()
  args$private$ooplah$abstract <- classname
  args$private$ooplah$fabstract <- function(obj) {
    if (identical(classname <- object_class(obj),
                  private(obj)$ooplah$abstract)) {
      stop(sprintf(
          "'%s' is an abstract class that can't be initialized.",
          classname
        ),
        call. = FALSE
      )
    }
  }

  do.call(R6::R6Class, args)
}
formals(AbstractClass) <- formals(R6::R6Class)

test_that("can create an abstract class", {
  expect_silent(AbstractClass("abstract"))
  expect_silent(AbstractClass("abstract", public = list(hi = "hi")))
  abs <- AbstractClass("abstract",
                       public = list(initialize = function(x) cat("hi")))
  expect_output(R6Class("child", inherit = abs)$new(), "hi")
  expect_error(abs$new(), "is an abstract class")
})

test_that("can't construct an abstract class", {
  expect_error(OoplahParent$new(), "is an abstract class")
})

test_that("can construct an abstract classes child", {
  expect_true(ooplah$new()$init)
})

#' Assert/test if 'x' is a R6 object or class
#' @title Is 'x' a R6 object or class?
#' @param x Object to test
#' @return Either TRUE/FALSE is testing if `x` inherits from
#' `R6` or `R6ClassGenerator`, otherwise returns `x` invisibly on assertion
#' if TRUE or returns an error if FALSE
#' @export
is.R6 <- function(x) { # nolint
  inherits(x, c("R6", "R6ClassGenerator"))
}

#' Assert/test if 'x' is a R6 class
#' @title Is 'x' a R6 class?
#' @param x Object to test
#' @return Either TRUE/FALSE is testing if `x` inherits from
#' `R6ClassGenerator`, otherwise returns `x` invisibly on assertion if TRUE or
#' returns an error if FALSE
#' @export
is.R6Class <- function(x) { # nolint
  inherits(x, "R6ClassGenerator")
}

#' Assert/test if 'x' is a R6 object
#' @title Is 'x' a R6 object?
#' @param x Object to test
#' @return Either TRUE/FALSE is testing if `x` inherits from `R6`, otherwise
#' returns `x` invisibly on assertion if TRUE or returns an error if FALSE
#' @export
is.R6Object <- function(x) { # nolint
  inherits(x, "R6")
}

#' @rdname is.R6
#' @export
assert_R6 <- function(x) { # nolint
  if (is.R6(x)) {
    invisible(x)
  } else {
    stop(sprintf("'%s' is not an R6 class or object", deparse(substitute(x))))
  }
}

#' @rdname is.R6Object
#' @export
assert_R6Object <- function(x) { # nolint
  if (is.R6Object(x)) {
    invisible(x)
  } else {
    stop(sprintf("'%s' is not an R6 object", deparse(substitute(x))))
  }
}

#' @rdname is.R6Class
#' @export
assert_R6Class <- function(x) { # nolint
  if (is.R6Class(x)) {
    invisible(x)
  } else {
    stop(sprintf("'%s' is not an R6 class", deparse(substitute(x))))
  }
}

objlah <- ooplah$new()

test_that("is.R6X", {
  expect_true(is.R6(ooplah))
  expect_true(is.R6(objlah))
  expect_false(is.R6(1))

  expect_true(is.R6Class(ooplah))
  expect_false(is.R6Class(objlah))

  expect_false(is.R6Object(ooplah))
  expect_true(is.R6Object(objlah))
})

test_that("assert R6X", {
  expect_equal(assert_R6(ooplah), ooplah)
  expect_equal(assert_R6(objlah), objlah)
  expect_error(assert_R6(1), "'1' is not")

  expect_equal(assert_R6Class(ooplah), ooplah)
  expect_error(assert_R6Class(objlah), "'objlah' is not an R6 class")

  expect_equal(assert_R6Object(objlah), objlah)
  expect_error(assert_R6Object(ooplah), "'ooplah' is not an R6 object")
})

## Test Results

No  WARNINGs, or ERRORs.

NOTEs:

* New submission
* Possibly unsafe calls - unlockBinding. These are required for the function
  which is specifically designed to modify the bindings of given environments

## Test environments

* Windows, R Release
* Mac OS X, R Release
* Ubuntu, R Release
* Ubuntu, R Oldrel
* Ubuntu, R Devel

## Reverse Dependencies

All reverse dependencies OK.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ooplah.R
\name{ooplah}
\alias{ooplah}
\title{R6 Class for testing and examples}
\description{
R6 Class for testing and examples
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DecoratorClass.R
\name{DecoratorClass}
\alias{DecoratorClass}
\title{Create an abstract R6 Class}
\description{
Creates a decorator R6 class by placing a thin wrapper around \link[R6:R6Class]{R6::R6Class}
which allows the constructed class to inherit the fields and methods of
the given object.
}
\details{
The decorator design pattern allows methods to be added to an
object without bloating the interface with too many methods on construction
and without causing large inheritance trees. A decorator class contains
fields/methods that are 'added' to the given object in construction, this
is made clearer in examples.

There are three possibilities when trying to decorate an object with a
field/method that already exists:
\enumerate{
\item \code{exists = "skip"} (default) - This will decorate the object with all
fields/methods that don't already exist
\item \code{exists = "error"} - This will throw an error and prevent the
object being decorated
\item \code{exists = "overwrite"} - This will decorate the object with all
fields/methods from the decorator and overwrite ones with the same name
if they already exist
}

Decorators are currently not cloneable.

All arguments of \link[R6:R6Class]{R6::R6Class} can be used as usual, see full
details at \link[R6:R6Class]{R6::R6Class}.
}
\examples{
library(R6)

## Create two decorators
# Works with active bindings...
dec1 <- DecoratorClass("dec1", active = list(hi = function() "Hi World"))
# And public fields...
dec2 <- DecoratorClass("dec2", public = list(goodbye = "Goodbye World"))

## Create an object to decorate
oop <- ooplah$new()
oop$hello()


## Decorate with dec1 by constructing dec1 with object oop:
dec_oop <- dec1$new(oop) # equiv `decorate(oop, dec1)`
## We have all original methods from oop
dec_oop$hello()
# It's inherited methods
dec_oop$init
# And now decorated methods
dec_oop$hi

## We can decorate again
redec_oop <- dec2$new(dec_oop)
redec_oop$hello()
redec_oop$init
redec_oop$hi
# And now
redec_oop$goodbye

# Notice the class reflects all decorators, the original object and parents,
#  and adds the 'Decorator' class
class(redec_oop)

## Decorators also work with inheritance
parent_dec <- DecoratorClass("parent_dec",
  public = list(hi = function() "Hi!"))
child_dec <- DecoratorClass("child_dec", inherit = parent_dec)
dec_oop <- child_dec$new(ooplah$new())
dec_oop$hi()

## Three possibilities if the method/field name already exists:
oop <- ooplah$new()
exists_dec <- DecoratorClass("exists_dec",
  public = list(hello = function() "Hi!"))

# 1. skip (default)
oop$hello()
exists_dec$new(oop, exists = "skip")$hello()

# 2. error
\dontrun{
exists_dec$new(oop)
exists_dec$new(oop, exists = "error")
}

# 3. overwrite
oop$hello()
exists_dec$new(oop, exists = "overwrite")$hello()

## Cloning
# Note that by default the decorated object is not cloned
dec <- DecoratorClass("dec", active = list(hi = function() "Hi World"))
dec_oop <- dec$new(oop)
dec_oop$logically
oop$logically <- FALSE
dec_oop$logically

}
\references{
Gamma, E., Helm, R., Johnson, R., & Vlissides, J. (1996).
Design Patterns: Elements of Reusable Software.
Addison-Wesley Professional Computing Series (p. 395).
}
\seealso{
\link{decorate}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/object_class.R
\name{object_class}
\alias{object_class}
\alias{get_object_class}
\alias{object_classes}
\title{Get class of an object (possibly with inheritance)}
\usage{
object_class(object, ancestor = 0)

get_object_class(object, ancestor = 0, ...)

object_classes(..., objects = list(...))
}
\arguments{
\item{object}{\code{ANY} \cr Object to get the class of}

\item{ancestor}{\code{(integer(1))} \cr If greater than 0 then the given ancestor
to get the class for, see examples}

\item{...}{\code{ANY} \cr Objects to \code{vapply} over}

\item{objects}{\code{(list(1))} \cr Alternative constructor with \code{list} of objects}
}
\description{
Find class of an object or an ancestor of the object. In contrast to \code{class}
which returns a class object and all its ancestors, this function returns
either the class of the object itself, or the class of one of its ancestors.
}
\details{
\code{object_classes} is a stripped-down wrapper to get the class of multiple
objects
}
\examples{
library(R6)

class_a <- R6Class("class_a")
class_b <- R6Class("class_b", inherit = class_a)
class(class_b$new())
object_class(class_b$new())
object_class(class_b$new(), 1)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/is.R6.R
\name{is.R6Class}
\alias{is.R6Class}
\alias{assert_R6Class}
\title{Is 'x' a R6 class?}
\usage{
is.R6Class(x)

assert_R6Class(x)
}
\arguments{
\item{x}{Object to test}
}
\value{
Either TRUE/FALSE is testing if \code{x} inherits from
\code{R6ClassGenerator}, otherwise returns \code{x} invisibly on assertion if TRUE or
returns an error if FALSE
}
\description{
Assert/test if 'x' is a R6 class
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors.R
\name{private}
\alias{private}
\title{Get R6 object private environment}
\usage{
private(x)
}
\arguments{
\item{x}{(\code{R6}) \cr R6 object to get environment from, errors if not R6}
}
\description{
Access the private environment of an R6 object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors.R
\name{super}
\alias{super}
\title{Get R6 object parent environment}
\usage{
super(x)
}
\arguments{
\item{x}{(\code{R6}) \cr R6 object to get environment from, errors if not R6}
}
\description{
Access the parent environment of an R6 object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sugar.R
\name{decorate}
\alias{decorate}
\title{Sugar function for decoration}
\usage{
decorate(object, decorators, exists = c("skip", "error", "overwrite"), ...)
}
\arguments{
\item{object}{\verb{[R6::R6Class]} \cr R6 class to decorate.}

\item{decorators}{\verb{([DecorateClass]|character())} \cr
One or more decorators (by name or class) to decorate with.}

\item{exists}{\verb{(character(1)} \cr Expected behaviour if method exists in
\code{object} and \code{decorator}. One of: 1. \code{exists = "error"} (default) - This
will throw an error and prevent the object being decorated.
2. \code{exists = "skip"} - This will decorate the object with all fields/methods
that don't already exist. 3. \code{exists = "overwrite"} - This will decorate
the object with all fields/methods from the decorator and overwrite ones
with the same name if they already exist.}

\item{...}{\code{ANY} \cr Additional arguments passed to \link{get}.}
}
\description{
Simple wrapper around \code{decorator$new(object, exists)}
}
\examples{
library(R6)

## Define decorators
dec1 <- DecoratorClass("dec1", public = list(goodbye = "Goodbye World"))
dec2 <- DecoratorClass("dec2", public = list(goodbye2 = "Goodbye World 2"))

oop <- ooplah$new()
oop$goodbye
dec_oop <- decorate(oop, c(dec1, dec2))
dec_oop$goodbye
dec_oop$goodbye2

## Equivalently
oop <- ooplah$new()
decorate(oop, c("dec1", "dec2"))

}
\seealso{
\link{DecoratorClass}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AbstractClass.R
\name{AbstractClass}
\alias{AbstractClass}
\title{Create an abstract R6 Class}
\description{
Creates an abstract R6 class by placing a thin wrapper around \link[R6:R6Class]{R6::R6Class}
which causes an error to be thrown if the class is directly constructed
instead of one of its descendants.
}
\details{
An abstract class is a class that cannot be constructed directly.
Instead they are used to define common fields/methods for child classes
that inherit from them.

All arguments of \link[R6:R6Class]{R6::R6Class} can be used as usual, see full
details at \link[R6:R6Class]{R6::R6Class}.
}
\examples{
library(R6)

ab <- AbstractClass("abstract", public = list(hello = "Hello World"))
\dontrun{
# errors
ab$new()
}
child <- R6Class("child", inherit = ab)
child$new()$hello

}
\references{
Gamma, E., Helm, R., Johnson, R., & Vlissides, J. (1996).
Design Patterns: Elements of Reusable Software.
Addison-Wesley Professional Computing Series (p. 395).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vxapply.R
\name{loapply}
\alias{loapply}
\title{Specialised lapply for objects}
\usage{
loapply(X, FUN, ...)
}
\arguments{
\item{X, ...}{See \link{lapply}}

\item{FUN}{Either a function to apply to each element of \code{X}, as in \link{lapply}
or the field/method name of an OOP object (see examples)}
}
\description{
Specialised \code{lapply} functions for R6 or other OOP classes.
This is simply a wrapper that detects if \code{FUN} is a function, in which
case \code{lapply} is used as usual, or a string, in which case the given
field/method is returned as a list.
}
\examples{
## lapply as usual
loapply(c(1, 2, 3), identity)

## For R6 objects
objs <- list(ooplah$new(), ooplah$new())
# Public field
loapply(objs, "oop")
# Public method
loapply(objs, "hello")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vxapply.R
\name{vxapply}
\alias{vxapply}
\alias{vlapply}
\alias{viapply}
\alias{vnapply}
\alias{vcapply}
\alias{vzapply}
\alias{vrapply}
\title{Specialised vapply methods for atomic classes}
\usage{
vlapply(X, FUN, ..., USE.NAMES = TRUE)

viapply(X, FUN, ..., USE.NAMES = TRUE)

vnapply(X, FUN, ..., USE.NAMES = TRUE)

vcapply(X, FUN, ..., USE.NAMES = TRUE)

vzapply(X, FUN, ..., USE.NAMES = TRUE)

vrapply(X, FUN, ..., USE.NAMES = TRUE)
}
\arguments{
\item{X, ..., USE.NAMES}{See \link{vapply}}

\item{FUN}{Either a function to apply to each element of \code{X}, as in \link{vapply}
or the field/method name of an OOP object (see examples)}
}
\description{
Specialised \code{vapply} functions for scalars of each of the six atomic classes
in R:
}
\details{
\itemize{
\item logical (\code{vlapply})
\item integer (\code{viapply})
\item numeric/real (\code{vnapply})
\item character/string (\code{vcapply})
\item complex (\code{vzapply})
\item raw (\code{vrapply})
}

These are simply wrappers around \link{vapply} where \code{FUN.VALUE} is pre-filled
with a scalar of the given class.

In addition these can be applied to pull-out fields or methods from R6 or
other OOP objects by supplying the field/method name to \code{FUN}. See examples.
}
\examples{
## Specialised vapply
vlapply(logical(10), identity)
vzapply(complex(10), identity)

## For R6 objects
objs <- list(ooplah$new(), ooplah$new())

# Public field
vcapply(objs, "oop")

# Public method
vcapply(objs, "exclaim", "ARGH")
vcapply(objs, "hello")
vnapply(objs, "generate", 1)

# Active binding
vlapply(objs, "logically")
}
